// Datei: delay.c
// Verzgerungsschleifen
//
// Holger Klabunde 
// 01.05.2001
// Compiler CC5x

#include "prozess.h"      /* Der verwendete Prozessor */

//Fr Taktfrequenz des PIC = 4MHz
//Ein Taktzyklus=1us
//delay<=255 !!
unsigned char del;

//Assemblerbefehle zwischen #asm und #endasm !! klein !! schreiben
//Kollidiert sonst mit inline.h

void Delay1ms(unsigned char delay)
{
 del=delay;
#asm

DLMS4M1
   movlw 0xF9          //1
   movwf FSR           //1

DLMS4M2                //4 cycles
     nop               //1
     decfsz FSR        //1
     goto  DLMS4M2     //2

   decfsz del     //1
   goto DLMS4M1        //2
#endasm
}

void Delay100us(unsigned char delay)
{
 del=delay;
#asm

DLUS4M1
   movlw 0x19          //1 Wert 25
   movwf FSR           //1

DLUS4M2                //4 cycles
     nop               //1
     decfsz FSR        //1
     goto  DLUS4M2     //2

   decfsz del     //1
   goto DLUS4M1        //2
#endasm
}

//2 Cycles for CAll
//2 Cycles for RET
void Delay10us()
{
#asm
 nop
 nop
 nop
 nop
 nop
 nop
#endasm
}
